import { world } from "@minecraft/server"
import { ActionFormData } from "@minecraft/server-ui"

const ui = new ActionFormData()
    .title("Form")
    .body("")
    .button("button1")
    .button("button2")
    .button("button3");

const customUi = new ActionFormData()
    .title("Main")
    .body("")
    .button("", "textures/ui/jarvis")
    .button("SUIT", "textures/ui/suit")
    .button("Settings", "textures/ui/sett")
    .button("Skins", "textures/ui/icon_hangar");

const jarvisUi = new ActionFormData()
    .title("Jarvis")
    .body("")
    .button("COMBAT MODE", "textures/ui/j/combat")
    .button("COMBAT OFF", "textures/ui/j/combatoff")
    .button("UNMASK", "textures/ui/j/unmask")
    .button("MASK", "textures/ui/j/mask")
    .button("Missile", "textures/ui/j/missiles")
    .button("PLANT MINE", "textures/ui/j/mine")
    .button("DETONATE MINE", "textures/ui/j/detonate")
    .button("SCAN", "textures/ui/j/scan")
    .button("ROCKET BLAST", "textures/ui/j/rocketblast")
    .button("BLADES", "textures/ui/j/blades")
    .button("Ultra", "textures/ui/j/ultra")
    .button("Lasers", "textures/ui/j/lasers");

const colUi = new ActionFormData()
    .title("Customize")
    .body("")
    .button("Default", "textures/ui/sc/def")
    .button("White", "textures/ui/sc/white")
    .button("Cyan", "textures/ui/sc/cyan")
    .button("Diamon", "textures/ui/sc/diamon");
    
world.afterEvents.itemUse.subscribe(async (event) => {
    const { source, itemStack } = event;
    
    switch (itemStack.typeId) {
        case "minecraft:compass":
            ui.show(source); 
            break;
        
        case "nk:jarvis": {
            const res = await customUi.show(source);
            
            // If JARVIS button is clicked
            if (res.selection === 0) {
                // Open the JARVIS menu and handle the selection immediately
                const jarvisRes = await jarvisUi.show(source);
                
                // Handle JARVIS menu actions
                if (jarvisRes.selection === 0) combat(source);
                if (jarvisRes.selection === 1) combatoff(source);
                if (jarvisRes.selection === 2) unmask(source);
                if (jarvisRes.selection === 3) mask(source);
                if (jarvisRes.selection === 4) missile(source);
                if (jarvisRes.selection === 5) plantmine(source);
                if (jarvisRes.selection === 6) detonate(source);
                if (jarvisRes.selection === 7) scan(source);
                if (jarvisRes.selection === 8) rocketblast(source);
                if (jarvisRes.selection === 9) blades(source);
                if (jarvisRes.selection === 10) ultra(source);
                if (jarvisRes.selection === 11) lasers(source);
            };
            if (res.selection === 1) {
                // Open the JARVIS menu and handle the selection immediately
                const colRes = await colUi.show(source);

                if (colRes.selection === 0) def(source);
                if (colRes.selection === 1) white(source);
                if (colRes.selection === 2) cyan(source);
                if (colRes.selection === 3) diamon(source);
            }
            break;
        }
    }
});
function combat(player) {
    player.runCommand('tag @s add extrem');
    player.runCommand('replaceitem entity @p slot.hotbar 6 nk:combat');
}
function combatoff(player) {
    player.runCommand('tag @s remove extrem');
    player.runCommand('clear @p nk:combat');
    player.runCommand('camera @p clear');
}
function unmask(player) {
    player.runCommand('function unmask');
}
function mask(player) {
    player.runCommand('function mask');
}
function missile(player) {
    player.runCommand('function missile');
}
function scan(player) {
    player.runCommand('function scanning');
}
function rocketblast(player) {
    player.runCommand('replaceitem entity @p slot.hotbar 5 nk:rocketblast');
}
function blades(player) {
    player.runCommand('replaceitem entity @p slot.hotbar 5 nk:qilij');
}
function ultra(player) {
    player.runCommand('replaceitem entity @p slot.hotbar 5 nk:ultra');
}
function lasers(player) {
    player.runCommand('replaceitem entity @p slot.hotbar 5 nk:lasers');
}
function plantmine(player) {
	player.runCommand('function mine');
}
function detonate(player) {
	player.runCommand('function detonate');
}
function def(player) {
    player.runCommand('event entity @s col:def');
}
function white(player) {
    player.runCommand('event entity @s col:white');
}
function cyan(player) {
	player.runCommand('event entity @s col:cyan');
}
function diamon(player) {
	player.runCommand('event entity @s col:diamon');
}